export declare type Reducer<S, A> = {
    (state: S, action: A): S;
};
export declare type GetRenderingRef = () => any;
export declare type GetElement = (comp: any) => any;
export declare type ForceUpdate = (ref: any) => void;
export declare type StashConfig = {
    getRenderingRef: GetRenderingRef;
    getElement: GetElement;
    forceUpdate: ForceUpdate;
};
export declare type Listener2<S, Vars, Return> = (stash: S, vars?: Vars) => Return;
export declare type StashField<V, R> = (vars?: V) => R;
export declare type SEV<S, Vars, Return> = {
    sel2: Listener2<S, Vars, Return>;
    caller2: any | null;
    vars2: Vars | null;
};
export interface HTMLStencilElement extends HTMLElement {
    componentOnReady(): Promise<this>;
}
export declare type BaseAction<Payload> = {
    type: string;
    payload?: Payload;
};
export declare type StashAction<P = undefined> = (args?: {
    payload: P;
}) => CustomEvent<{
    type: string;
    payload?: P;
}>;
export declare type OnCleanup = {
    (): void;
};
export declare type ThunkContext = {
    setOnCleanup: (onCleanup: OnCleanup) => void;
};
export declare type Thunk<S, A extends {
    type: string;
}, R = any | undefined> = {
    (dispatch: Dispatch<A>, getAction: () => S, context: ThunkContext): Promise<R> | R;
};
export declare type Dispatch<Action extends {
    type: string;
}> = (args: Action) => void;
export declare type ThunkDispatch<Action extends {
    type: string;
}, S> = (args: Action | ((...args: any) => Thunk<S, Action, any> | Promise<Thunk<S, Action, any>>)) => any | void | Promise<any | void>;
